

<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>gwmat.cosmology &mdash; GWMAT: Gravitational Wave Microlensing Analysis Tools 1.0.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=7ab3649f" />

  
      <script src="../../_static/jquery.js?v=5d32c60e"></script>
      <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
      <script src="../../_static/documentation_options.js?v=8d563738"></script>
      <script src="../../_static/doctools.js?v=9a2dae69"></script>
      <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            GWMAT: Gravitational Wave Microlensing Analysis Tools
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../gwmat.html">gwmat package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">GWMAT: Gravitational Wave Microlensing Analysis Tools</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../gwmat.html">gwmat</a></li>
      <li class="breadcrumb-item active">gwmat.cosmology</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for gwmat.cosmology</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This module contains the `Cosmology` class, which provides</span>
<span class="sd">essential functions for computing cosmological distances</span>
<span class="sd">(such as luminosity distance and comoving distance)</span>
<span class="sd">based on redshift and vice-versa.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Anuj Mishra &lt;anuj.mishra@ligo.org&gt;&quot;</span><span class="p">]</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">scipy.integrate</span> <span class="kn">import</span> <span class="n">quad</span>

<span class="kn">from</span> <span class="nn">.constants</span> <span class="kn">import</span> <span class="n">C_SI</span>


<div class="viewcode-block" id="Cosmology">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology">[docs]</a>
<span class="k">class</span> <span class="nc">Cosmology</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Contains basic functions to compute cosmological distances</span>
<span class="sd">    as functions of redshift, and vice-versa.</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span> <span class="n">omega_m</span><span class="o">=</span><span class="mf">0.315</span><span class="p">,</span> <span class="n">omega_lambda</span><span class="o">=</span><span class="mf">0.685</span><span class="p">,</span> <span class="n">omega_k</span><span class="o">=</span><span class="mf">0.0</span><span class="p">,</span> <span class="n">hubble_constant</span><span class="o">=</span><span class="mf">69.8e3</span>
    <span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fixing cosmology.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        omega_m : float, optional</span>
<span class="sd">            matter_density, by default 0.315</span>
<span class="sd">        omega_lambda : float, optional</span>
<span class="sd">            dark_energy_density, by default 0.685</span>
<span class="sd">        omega_k : float, optional</span>
<span class="sd">            determines curvature, by default 0.</span>
<span class="sd">        hubble_constant : float, optional</span>
<span class="sd">            Hubbles constant (ms^-1 Mpc^-1), by default 69.8e3</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">omega_m</span> <span class="o">=</span> <span class="n">omega_m</span>  <span class="c1"># matter_density</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">omega_lambda</span> <span class="o">=</span> <span class="n">omega_lambda</span>  <span class="c1"># dark_energy_density</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">omega_k</span> <span class="o">=</span> <span class="n">omega_k</span>  <span class="c1"># determines curvature</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">omega_r</span> <span class="o">=</span> <span class="p">(</span>
            <span class="mi">1</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_m</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_lambda</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_k</span>
        <span class="p">)</span>  <span class="c1"># radiation_energy_density</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hubble_constant</span> <span class="o">=</span> <span class="n">hubble_constant</span>  <span class="c1"># (ms^-1 Mpc^-1)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hubble_distance</span> <span class="o">=</span> <span class="n">C_SI</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">hubble_constant</span>  <span class="c1"># Mpc</span>

<div class="viewcode-block" id="Cosmology.inverse_dimensionless_hubble_parameter">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.inverse_dimensionless_hubble_parameter">[docs]</a>
    <span class="k">def</span> <span class="nf">inverse_dimensionless_hubble_parameter</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">z</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns hubble_constant/H(z) = 1/E(z), inverse</span>
<span class="sd">        of the dimensionless Hubble_parameter.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        z : float</span>
<span class="sd">            Redshift</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            hubble_constant/H(z) = 1/E(z)</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">hubble_distance</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">omega_r</span> <span class="o">*</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">z</span><span class="p">)</span> <span class="o">**</span> <span class="mi">4</span>
            <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_m</span> <span class="o">*</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">z</span><span class="p">)</span> <span class="o">**</span> <span class="mi">3</span>
            <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_k</span> <span class="o">*</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">z</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span>
            <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_lambda</span><span class="p">,</span>
            <span class="o">-</span><span class="mi">1</span> <span class="o">/</span> <span class="mi">2</span><span class="p">,</span>
        <span class="p">)</span></div>


<div class="viewcode-block" id="Cosmology.compute_comoving_distance">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.compute_comoving_distance">[docs]</a>
    <span class="k">def</span> <span class="nf">compute_comoving_distance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">z</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the comoving distance</span>
<span class="sd">        as a function of redshift z.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        z : float</span>
<span class="sd">            Redshift</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            The comoving distance, in Mpc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">quad</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">inverse_dimensionless_hubble_parameter</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">z</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span></div>


<div class="viewcode-block" id="Cosmology.compute_angular_diameter_distance">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.compute_angular_diameter_distance">[docs]</a>
    <span class="k">def</span> <span class="nf">compute_angular_diameter_distance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">z</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the angular diameter distance</span>
<span class="sd">        as a function of redshift z.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        z : float</span>
<span class="sd">            Redshift</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            The angular diameter distance, in Mpc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="nb">pow</span><span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">z</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z</span><span class="p">)</span></div>


<div class="viewcode-block" id="Cosmology.angular_diameter_distance_between_redshifts">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.angular_diameter_distance_between_redshifts">[docs]</a>
    <span class="k">def</span> <span class="nf">angular_diameter_distance_between_redshifts</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">z1</span><span class="p">,</span> <span class="n">z2</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the angular diameter distance</span>
<span class="sd">        between two redshifts z1 and z2.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        z1 : float</span>
<span class="sd">            First Redshift</span>
<span class="sd">        z2 : float</span>
<span class="sd">            Second Redshift</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            The angular diameter distance between</span>
<span class="sd">            the two redshift, in Mpc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="nb">pow</span><span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">z2</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z2</span><span class="p">)</span>
            <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span>
                <span class="mi">1</span>
                <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_r</span>
                <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z1</span><span class="p">)</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">hubble_distance</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>
            <span class="p">)</span>
            <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z1</span><span class="p">)</span>
            <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span>
                <span class="mi">1</span>
                <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">omega_r</span>
                <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z2</span><span class="p">)</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">hubble_distance</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>
            <span class="p">)</span>
        <span class="p">)</span></div>


<div class="viewcode-block" id="Cosmology.compute_luminosity_distance">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.compute_luminosity_distance">[docs]</a>
    <span class="k">def</span> <span class="nf">compute_luminosity_distance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">z</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the luminosity distance</span>
<span class="sd">        as a function of redshift z.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        z : float</span>
<span class="sd">            Redshift</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            The luminosity distance, in Mpc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">z</span><span class="p">)</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z</span><span class="p">)</span></div>


<div class="viewcode-block" id="Cosmology.find_redshift_from_comoving_distance">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.find_redshift_from_comoving_distance">[docs]</a>
    <span class="k">def</span> <span class="nf">find_redshift_from_comoving_distance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dc</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Finds the redshift corresponding a given</span>
<span class="sd">        comoving distance using binary search.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        dc : float</span>
<span class="sd">            The comoving distance, in Mpc.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Redshift</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">z_min</span><span class="p">,</span> <span class="n">z_max</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">10</span>
        <span class="n">z</span> <span class="o">=</span> <span class="p">(</span><span class="n">z_min</span> <span class="o">+</span> <span class="n">z_max</span><span class="p">)</span> <span class="o">/</span> <span class="mf">2.0</span>
        <span class="n">dist</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z</span><span class="o">=</span><span class="n">z</span><span class="p">)</span>
        <span class="k">while</span> <span class="nb">abs</span><span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="n">dc</span> <span class="o">/</span> <span class="n">dist</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mf">0.001</span><span class="p">:</span>
            <span class="n">z</span> <span class="o">=</span> <span class="p">(</span><span class="n">z_min</span> <span class="o">+</span> <span class="n">z_max</span><span class="p">)</span> <span class="o">/</span> <span class="mf">2.0</span>
            <span class="n">dist</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_comoving_distance</span><span class="p">(</span><span class="n">z</span><span class="o">=</span><span class="n">z</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">dist</span> <span class="o">&lt;</span> <span class="n">dc</span><span class="p">:</span>
                <span class="n">z_min</span> <span class="o">=</span> <span class="n">z</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">z_max</span> <span class="o">=</span> <span class="n">z</span>
        <span class="k">return</span> <span class="n">z</span></div>


<div class="viewcode-block" id="Cosmology.find_redshift_from_luminosity_distance">
<a class="viewcode-back" href="../../gwmat.html#gwmat.cosmology.Cosmology.find_redshift_from_luminosity_distance">[docs]</a>
    <span class="k">def</span> <span class="nf">find_redshift_from_luminosity_distance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">luminosity_distance</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Finds the redshift corresponding a given</span>
<span class="sd">        luminosity distance using binary search.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        luminosity_distance : float</span>
<span class="sd">            The luminosity distance, in Mpc.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float</span>
<span class="sd">            Redshift</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">z_min</span><span class="p">,</span> <span class="n">z_max</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">10</span>
        <span class="n">z</span> <span class="o">=</span> <span class="p">(</span><span class="n">z_min</span> <span class="o">+</span> <span class="n">z_max</span><span class="p">)</span> <span class="o">/</span> <span class="mf">2.0</span>
        <span class="n">dist</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_luminosity_distance</span><span class="p">(</span><span class="n">z</span><span class="o">=</span><span class="n">z</span><span class="p">)</span>
        <span class="k">while</span> <span class="nb">abs</span><span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="n">luminosity_distance</span> <span class="o">/</span> <span class="n">dist</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mf">0.001</span><span class="p">:</span>
            <span class="n">z</span> <span class="o">=</span> <span class="p">(</span><span class="n">z_min</span> <span class="o">+</span> <span class="n">z_max</span><span class="p">)</span> <span class="o">/</span> <span class="mf">2.0</span>
            <span class="n">dist</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">compute_luminosity_distance</span><span class="p">(</span><span class="n">z</span><span class="o">=</span><span class="n">z</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">dist</span> <span class="o">&lt;</span> <span class="n">luminosity_distance</span><span class="p">:</span>
                <span class="n">z_min</span> <span class="o">=</span> <span class="n">z</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">z_max</span> <span class="o">=</span> <span class="n">z</span>
        <span class="k">return</span> <span class="n">z</span></div>
</div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Anuj Mishra.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>